diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index d78e45c64..b39971d03 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -1,23 +1,22 @@
 package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 public class MobGhast extends MobFlying
-    implements Enemy
-{
+    implements Enemy {
     public static final int DATA_CHARGING = 16;
     public int courseChangeCooldown;
     public double waypointX;
@@ -29,200 +28,163 @@ public class MobGhast extends MobFlying
     public int attackCharge;
 
 
-    public MobGhast(World world)
-    {
+    public MobGhast(World world) {
         super(world);
-        courseChangeCooldown = 0;
-        targetedEntity = null;
-        aggroCooldown = 0;
-        attackChargeO = 0;
-        attackCharge = 0;
+        this.courseChangeCooldown = 0;
+        this.targetedEntity = null;
+        this.aggroCooldown = 0;
+        this.attackChargeO = 0;
+        this.attackCharge = 0;
         setTextureIdentifier("minecraft", "ghast");
         setSize(4F, 7F);
-        fireImmune = true;
-        scoreValue = 1000;
-        bb.grow(2F, 3F, 2F);
-        mobDrops.add(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 0, 2));
+        this.fireImmune = true;
+        this.scoreValue = 1000;
+        MathHelper.aabbGrow(this.bb, 2f, 3f, 2f, this.bb);
+        this.mobDrops.add(new WeightedRandomLootObject(Items.GUNPOWDER.getDefaultStack(), 0, 2));
     }
 
     @Override
-	protected void defineSynchedData()
-    {
+    protected void defineSynchedData() {
         super.defineSynchedData();
-        entityData.define(DATA_CHARGING, (byte) 0, Byte.class);
+        this.entityData.define(DATA_CHARGING, (byte) 0, Byte.class);
     }
 
     @Override
-    public @NotNull String getEntityTexture()
-    {
-        if (this.entityData.getByte(DATA_CHARGING) != 1)
-        {
+    public @NotNull String getEntityTexture() {
+        if (this.entityData.getByte(DATA_CHARGING) != 1) {
             return super.getEntityTexture();
-        }
-        else
-        {
+        } else {
             return "/assets/minecraft/textures/entity/ghast_fire/" + getTextureReference() + ".png";
         }
     }
 
     @Override
-    public @NotNull String getDefaultEntityTexture()
-    {
-        if (this.entityData.getByte(DATA_CHARGING) != 1)
-        {
+    public @NotNull String getDefaultEntityTexture() {
+        if (this.entityData.getByte(DATA_CHARGING) != 1) {
             return super.getEntityTexture();
-        }
-        else
-        {
+        } else {
             return "/assets/minecraft/textures/entity/ghast_fire/0.png";
         }
     }
 
-    public void tick()
-    {
+    public void tick() {
         //prevAttackCounter = attackCounter; -uncomment if it still doesn't work
-        if(world.isClientSide)
-        {
-            byte i = entityData.getByte(DATA_CHARGING);
-            if(i > 0 && attackCharge == 0)
-            {
-                world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+        if (this.world.isClientSide) {
+            byte i = this.entityData.getByte(DATA_CHARGING);
+            if (i > 0 && this.attackCharge == 0) {
+                this.world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
             }
-            attackCharge += i;
-            if(attackCharge < 0)
-            {
-                attackCharge = 0;
+            this.attackCharge += i;
+            if (this.attackCharge < 0) {
+                this.attackCharge = 0;
             }
-            if(attackCharge >= 20)
-            {
-                attackCharge = 20;
+            if (this.attackCharge >= 20) {
+                this.attackCharge = 20;
             }
-            if(attackCharge >= 20 && i == 0){
-                world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
-                attackCharge = -40;
+            if (this.attackCharge >= 20 && i == 0) {
+                this.world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
+                this.attackCharge = -40;
             }
         }
         super.tick();
     }
 
     @Override
-	protected void updateAI()
-    {
-        if(!world.isClientSide && !world.getDifficulty().canHostileMobsSpawn())
-        {
+    protected void updateAI() {
+        if (!this.world.isClientSide && !this.world.getDifficulty().canHostileMobsSpawn()) {
             remove();
         }
         tryToDespawn();
-        attackChargeO = attackCharge;
-        double d = waypointX - x;
-        double d1 = waypointY - y;
-        double d2 = waypointZ - z;
+        this.attackChargeO = this.attackCharge;
+        double d = this.waypointX - this.x;
+        double d1 = this.waypointY - this.y;
+        double d2 = this.waypointZ - this.z;
         double d3 = MathHelper.sqrt(d * d + d1 * d1 + d2 * d2);
-        if(d3 < 1.0D || d3 > 60D)
-        {
-            waypointX = x + (double)((random.nextFloat() * 2.0F - 1.0F) * 16F);
-            waypointY = y + (double)((random.nextFloat() * 2.0F - 1.0F) * 16F);
-            waypointZ = z + (double)((random.nextFloat() * 2.0F - 1.0F) * 16F);
+        if (d3 < 1.0D || d3 > 60D) {
+            this.waypointX = this.x + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
+            this.waypointY = this.y + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
+            this.waypointZ = this.z + (double) ((this.random.nextFloat() * 2.0F - 1.0F) * 16F);
         }
-        if(courseChangeCooldown-- <= 0)
-        {
-            courseChangeCooldown += random.nextInt(5) + 2;
-            if(isCourseTraversable(waypointX, waypointY, waypointZ, d3))
-            {
-                xd += (d / d3) * 0.1D;
-                yd += (d1 / d3) * 0.1D;
-                zd += (d2 / d3) * 0.1D;
-            } else
-            {
-                waypointX = x;
-                waypointY = y;
-                waypointZ = z;
+        if (this.courseChangeCooldown-- <= 0) {
+            this.courseChangeCooldown += this.random.nextInt(5) + 2;
+            if (isCourseTraversable(this.waypointX, this.waypointY, this.waypointZ, d3)) {
+                this.xd += (d / d3) * 0.1D;
+                this.yd += (d1 / d3) * 0.1D;
+                this.zd += (d2 / d3) * 0.1D;
+            } else {
+                this.waypointX = this.x;
+                this.waypointY = this.y;
+                this.waypointZ = this.z;
             }
         }
-        if(targetedEntity != null && targetedEntity.removed)
-        {
-            targetedEntity = null;
+        if (this.targetedEntity != null && this.targetedEntity.removed) {
+            this.targetedEntity = null;
         }
-        if(targetedEntity == null || aggroCooldown-- <= 0)
-        {
-            targetedEntity = world.getClosestPlayerToEntity(this, 100D);
-            if (targetedEntity != null && !((Player) targetedEntity).getGamemode().areMobsHostile())
-            {
-            	targetedEntity = null;
+        if (this.targetedEntity == null || this.aggroCooldown-- <= 0) {
+            this.targetedEntity = this.world.getClosestPlayerToEntity(this, 100D);
+            if (this.targetedEntity != null && !((Player) this.targetedEntity).getGamemode().areMobsHostile()) {
+                this.targetedEntity = null;
             }
-            if(targetedEntity != null)
-            {
-                aggroCooldown = 20;
+            if (this.targetedEntity != null) {
+                this.aggroCooldown = 20;
             }
         }
         double d4 = 64D;
-        if(targetedEntity != null && targetedEntity.distanceToSqr(this) < d4 * d4)
-        {
+        if (this.targetedEntity != null && this.targetedEntity.distanceToSqr(this) < d4 * d4) {
             double d8 = 4D;
-            Vec3 vec3 = getViewVector(1.0F);
-            double dX = targetedEntity.x - x;
-            double dY = targetedEntity.y - y;
-            double dZ = targetedEntity.z - z;
+            Vector3dc viewVec = getViewVector(1.0F);
+            assert viewVec != null;
+            double dX = this.targetedEntity.x - this.x;
+            double dY = this.targetedEntity.y - this.y;
+            double dZ = this.targetedEntity.z - this.z;
             double dist = MathHelper.sqrt(dX * dX + dY * dY + dZ * dZ);
-            double vX = dX + (targetedEntity.xd * dist/7.5d) - vec3.x * d8;
-            double vY = dY + (targetedEntity.yd * dist/7.5d) - ((double)(bbHeight / 2.0F) + 0.5D);
-            double vZ = dZ + (targetedEntity.zd * dist/7.5d) - vec3.z * d8;
-            yBodyRot = yRot = (-(float) java.lang.Math.atan2(vX, vZ) * 180F) / MathHelper.PI;
-            if(canEntityBeSeen(targetedEntity))
-            {
-                if(attackCharge == 10)
-                {
-                    world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+            double vX = dX + (this.targetedEntity.xd * dist / 7.5d) - viewVec.x() * d8;
+            double vY = dY + (this.targetedEntity.yd * dist / 7.5d) - ((double) (this.bbHeight / 2.0F) + 0.5D);
+            double vZ = dZ + (this.targetedEntity.zd * dist / 7.5d) - viewVec.z() * d8;
+            this.yBodyRot = this.yRot = (-(float) java.lang.Math.atan2(vX, vZ) * 180F) / MathHelper.PI;
+            if (canEntityBeSeen(this.targetedEntity)) {
+                if (this.attackCharge == 10) {
+                    this.world.playSoundAtEntity(null, this, "mob.ghast.charge", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
                 }
-                attackCharge++;
-                if(attackCharge == 20)
-                {
-                    world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
-                    ProjectileFireball fireball = new ProjectileFireball(world, this, vX, vY, vZ);
-
-                    fireball.x = x + vec3.x * d8;
-                    fireball.y = y + (double)(bbHeight / 2.0F) + 0.5D;
-                    fireball.z = z + vec3.z * d8;
-                    world.entityJoinedWorld(fireball);
-                    attackCharge = -40;
+                this.attackCharge++;
+                if (this.attackCharge == 20) {
+                    this.world.playSoundAtEntity(null, this, "mob.ghast.fireball", getSoundVolume(), (this.random.nextFloat() - this.random.nextFloat()) * 0.2F + 1.0F);
+                    ProjectileFireball fireball = new ProjectileFireball(this.world, this, vX, vY, vZ);
+
+                    fireball.x = this.x + viewVec.x() * d8;
+                    fireball.y = this.y + (double) (this.bbHeight / 2.0F) + 0.5D;
+                    fireball.z = this.z + viewVec.z() * d8;
+                    this.world.entityJoinedWorld(fireball);
+                    this.attackCharge = -40;
                 }
-            } else
-            if(attackCharge > 0)
-            {
-                attackCharge--;
+            } else if (this.attackCharge > 0) {
+                this.attackCharge--;
             } else {
-                targetedEntity = null;
+                this.targetedEntity = null;
             }
-        } else
-        {
-            yBodyRot = yRot = (-(float) java.lang.Math.atan2(xd, zd) * 180F) / MathHelper.PI;
-            if(attackCharge > 0)
-            {
-                attackCharge--;
+        } else {
+            this.yBodyRot = this.yRot = (-(float) java.lang.Math.atan2(this.xd, this.zd) * 180F) / MathHelper.PI;
+            if (this.attackCharge > 0) {
+                this.attackCharge--;
             }
         }
-        if(!world.isClientSide)
-        {
-            byte chargeData = entityData.getByte(DATA_CHARGING);
-            byte chargeState = (byte)(attackCharge <= 10 ? 0 : 1);
-            if(chargeData != chargeState)
-            {
-                entityData.set(DATA_CHARGING, chargeState);
+        if (!this.world.isClientSide) {
+            byte chargeData = this.entityData.getByte(DATA_CHARGING);
+            byte chargeState = (byte) (this.attackCharge <= 10 ? 0 : 1);
+            if (chargeData != chargeState) {
+                this.entityData.set(DATA_CHARGING, chargeState);
             }
         }
     }
 
-    private boolean isCourseTraversable(double d, double d1, double d2, double d3)
-    {
-        double d4 = (waypointX - x) / d3;
-        double d5 = (waypointY - y) / d3;
-        double d6 = (waypointZ - z) / d3;
-        AABB axisalignedbb = bb.copy();
-        for(int i = 1; (double)i < d3; i++)
-        {
-            axisalignedbb.move(d4, d5, d6);
-            if(world.getCubes(this, axisalignedbb).size() > 0)
-            {
+    private boolean isCourseTraversable(double x, double y, double z, double d3) {
+        double d4 = (x - this.x) / d3;
+        double d5 = (y - this.y) / d3;
+        double d6 = (z - this.z) / d3;
+        AABBd aabb = new AABBd(this.bb);
+        for (int i = 1; (double) i < d3; i++) {
+            aabb.translate(d4, d5, d6);
+            if (!this.world.getCubes(this, aabb).isEmpty()) {
                 return false;
             }
         }
@@ -231,63 +193,52 @@ public class MobGhast extends MobFlying
     }
 
     @Override
-    public boolean hurt(Entity attacker, int i, DamageType type)
-    {
-        if(super.hurt(attacker, i, type))
-        {
-            if(passenger == attacker || vehicle == attacker)
-            {
+    public boolean hurt(Entity attacker, int i, DamageType type) {
+        if (super.hurt(attacker, i, type)) {
+            if (this.passenger == attacker || this.vehicle == attacker) {
                 return true;
             }
-            if(attacker != this)
-            {
-                targetedEntity = attacker;
-                aggroCooldown = 60;
+            if (attacker != this) {
+                this.targetedEntity = attacker;
+                this.aggroCooldown = 60;
             }
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
 
     @Override
-    public String getLivingSound()
-    {
+    public String getLivingSound() {
         return "mob.ghast.moan";
     }
 
     @Override
-	protected String getHurtSound()
-    {
+    protected String getHurtSound() {
         return "mob.ghast.scream";
     }
 
     @Override
-	protected String getDeathSound()
-    {
+    protected String getDeathSound() {
         return "mob.ghast.death";
     }
 
     @Override
-	protected float getSoundVolume()
-    {
+    protected float getSoundVolume() {
         return 10F;
     }
 
     @Override
-	public boolean canSpawnHere()
-    {
+    public boolean canSpawnHere() {
         return
             this.world.getDifficulty().canHostileMobsSpawn() &&
                 this.random.nextInt(20) == 0 &&
-                BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(MathHelper.floor(this.x), MathHelper.floor(this.y - this.heightOffset) - 1, MathHelper.floor(this.z))) &&
+                BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(new TilePos(this.x, this.y - this.heightOffset - 1, this.z))) &&
                 super.canSpawnHere();
     }
 
     @Override
-	public int getMaxSpawnedInChunk()
-    {
+    public int getMaxSpawnedInChunk() {
         return 1;
     }
 
@@ -298,6 +249,6 @@ public class MobGhast extends MobFlying
 
     @Override
     public int calcLightmap(float partialTick) {
-        return world.getLightmapCoord(15, 15);
+        return this.world.getLightmapCoord(15, 15);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index b07e251e9..a7f292162 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -4,37 +4,37 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.MobPathfinder;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 public abstract class MobMonster extends MobPathfinder
-    implements Enemy
-{
+    implements Enemy {
 
-    public MobMonster(@NotNull final World world)
-    {
+    public MobMonster(@NotNull final World world) {
         super(world);
-        attackStrength = 2;
+        this.attackStrength = 2;
     }
+
     @Override
-    public int getMaxHealth(){
+    public int getMaxHealth() {
         return 20;
     }
+
     @Override
-    protected void updateAI()
-    {
-        if(closestFireflyEntity == null) {
-            closestFireflyEntity = getClosestFireflyToEntity((int) x, (int) y, (int) z, 8F);
+    protected void updateAI() {
+        if (this.closestFireflyEntity == null) {
+            this.closestFireflyEntity = getClosestFireflyToEntity((int) this.x, (int) this.y, (int) this.z, 8F);
         }
 
-        if(closestFireflyEntity != null){
-            double dX = x - closestFireflyEntity.x;
-            double dZ = z - closestFireflyEntity.z;
+        if (this.closestFireflyEntity != null) {
+            double dX = this.x - this.closestFireflyEntity.x;
+            double dZ = this.z - this.closestFireflyEntity.z;
 
             double hypotenuse = Math.sqrt((dX * dX) + (dZ * dZ));
 
@@ -42,118 +42,97 @@ public abstract class MobMonster extends MobPathfinder
             dX = dX * scaleFactor;
             dZ = dZ * scaleFactor;
 
-            Vec3 distanceXYZ = Vec3.fromPool(x + dX, y, z + dZ);
-            pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor(distanceXYZ.x), MathHelper.floor(y), MathHelper.floor(distanceXYZ.z), 16F);
+            Vector3dc distanceXYZ = new Vector3d(this.x + dX, this.y, this.z + dZ);
+            this.pathToEntity = this.world.getEntityPathToTilePos(this, new TilePos(distanceXYZ), 16F);
         }
 
         super.updateAI();
     }
 
     @Override
-	public void onLivingUpdate()
-    {
+    public void onLivingUpdate() {
         float f = calcBrightness(1.0F);
-        if(f > 0.5F)
-        {
-            entityAge += 2;
+        if (f > 0.5F) {
+            this.entityAge += 2;
         }
         super.onLivingUpdate();
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         super.tick();
-        if(!world.isClientSide && !world.getDifficulty().canHostileMobsSpawn())
-        {
+        if (!this.world.isClientSide && !this.world.getDifficulty().canHostileMobsSpawn()) {
             remove();
         }
     }
 
     @Override
-	protected Entity findPlayerToAttack()
-    {
-        Player entityplayer = world.getClosestPlayerToEntity(this, 16D);
-        if(entityplayer != null && canEntityBeSeen(entityplayer) && entityplayer.getGamemode().areMobsHostile())
-        {
+    protected Entity findPlayerToAttack() {
+        Player entityplayer = this.world.getClosestPlayerToEntity(this, 16D);
+        if (entityplayer != null && canEntityBeSeen(entityplayer) && entityplayer.getGamemode().areMobsHostile()) {
             return entityplayer;
-        } else
-        {
+        } else {
             return null;
         }
     }
 
     @Override
-	public int getMaxSpawnedInChunk()
-    {
-        if(world.getSeasonManager().getCurrentSeason()== Seasons.OVERWORLD_SPRING)
+    public int getMaxSpawnedInChunk() {
+        if (this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
             return 2;
-        if(world.getSeasonManager().getCurrentSeason()== Seasons.OVERWORLD_WINTER)
+        if (this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
             return 8;
         return 4;
     }
 
     @Override
-    public boolean hurt(Entity attacker, int i, DamageType type)
-    {
-        if(super.hurt(attacker, i, type))
-        {
-            if(passenger == attacker || vehicle == attacker)
-            {
+    public boolean hurt(Entity attacker, int i, DamageType type) {
+        if (super.hurt(attacker, i, type)) {
+            if (this.passenger == attacker || this.vehicle == attacker) {
                 return true;
             }
-            if(attacker != this)
-            {
-                target = attacker;
+            if (attacker != this) {
+                this.target = attacker;
             }
             return true;
-        } else
-        {
+        } else {
             return false;
         }
     }
 
     @Override
-	protected void attackEntity(@NotNull Entity entity, float distance)
-    {
-        if(attackTime <= 0 && distance < 2.0F && entity.bb.maxY > bb.minY && entity.bb.minY < bb.maxY)
-        {
-            attackTime = 20;
-            entity.hurt(this, attackStrength, DamageType.COMBAT);
+    protected void attackEntity(@NotNull Entity entity, float distance) {
+        if (this.attackTime <= 0 && distance < 2.0F && entity.bb.maxY > this.bb.minY && entity.bb.minY < this.bb.maxY) {
+            this.attackTime = 20;
+            entity.hurt(this, this.attackStrength, DamageType.COMBAT);
         }
     }
 
     @Override
-	protected float getBlockPathWeight(int x, int y, int z)
-    {
-        return 0.5F - world.getLightBrightness(x, y, z);
+    protected float getBlockPathWeight(int x, int y, int z) {
+        return 0.5F - this.world.getLightBrightness(x, y, z);
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
     }
 
     @Override
-	public boolean canSpawnHere()
-    {
-        int blockX = MathHelper.floor(x);
-        int blockY = MathHelper.floor(bb.minY);
-        int blockZ = MathHelper.floor(z);
-        if(world.getSavedLightValue(LightLayer.Block, blockX, blockY, blockZ) > 0) return false;
-        if(world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) > random.nextInt(32))
+    public boolean canSpawnHere() {
+        TilePos blockPos = new TilePos(this.x, this.bb.minY, this.z);
+        if (this.world.getSavedLightValue(LightLayer.Block, blockPos) > 0) return false;
+        if (this.world.getSavedLightValue(LightLayer.Sky, blockPos) > this.random.nextInt(32))
             return false;
 
-        int blockLight = world.getBlockLightValue(blockX, blockY, blockZ);
-        if(world.getCurrentWeather() != null && world.getCurrentWeather().isMobDaylightSpawnAllowed())
-            blockLight = blockLight/2;
+        int blockLight = this.world.getBlockLightValue(blockPos);
+        if (this.world.getCurrentWeather() != null && this.world.getCurrentWeather().isMobDaylightSpawnAllowed())
+            blockLight = blockLight / 2;
 
         return blockLight <= 4 && super.canSpawnHere();
     }
